// Win32DlgOpenCV.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "Win32DlgOpenCV.h"

#include <opencv\cv.h>
#include <opencv\highgui.h>

#include <opencv2\core\core.hpp>
#include <opencv2\highgui\highgui.hpp>

//t@C֘A
//iR[h̓}`oCgɐݒ肵j
TCHAR szOpenFileName[MAX_PATH];
TCHAR szSaveFileName[MAX_PATH];

int openFileNameBox(HWND);      //GetOpenFileName֐p
int saveFileNameBox(HWND);      //GetSaveFileName֐p

//͉摜Ao͉摜
cv::Mat imgMatRead; //ǂݍݗp
cv::Mat imgMatWrite; //ݗpiۑۂ͂ɑΏۉ摜ݒ肷邱Ɓj
cv::Mat imgMatFix; //\p

//WIN32 BMP֘A
HWND hwPic = NULL;
HDC hDC = NULL;
HDC hDCPic = NULL;

IplImage *imgFromOpenCV = NULL;
IplImage img;

BITMAPINFO bmpInfo;
unsigned long* bmpData = NULL;

void iplTobmp(const IplImage*, BITMAPINFO&, unsigned long*);

//ȉ̊e֐ɂ肽OpenCV̏Ă
//摜ۑꍇ͕ϐ imgMatWrite ɕۑΏۉ摜ݒ肷
//Ƃ͕ۑ{^ŕۑo

//؂o摜̗̈
//ł͍ő100ƂĒ`
cv::Mat roi[100];

/*------------------------------------------------
  `FbN{bNX̎擾
-------------------------------------------------*/
BOOL checkInv(HWND hWnd)
{
	BOOL bCheck = SendMessage(GetDlgItem(hWnd, ID_INV), BM_GETCHECK, 0, 0);

	return bCheck;
}

/*------------------------------------------------
 1
-------------------------------------------------*/
void func1(HWND hWnd)
{
	////MessageBox(hWnd, "func1", "debug", MB_OK);
	if (imgMatRead.rows == 0){
		MessageBox(hWnd, "摜t@Cł", "G[", MB_OK);
		return;
	}

	//͉摜Ał͖t@Cǂݍ
	cv::Mat imgIn = cv::imread((const std::string&)szOpenFileName, 1); //3`lJ[摜œǂݍ;

	//O[XP[
	cv::Mat grayImage, binImage;
	cv::cvtColor(imgIn, grayImage, CV_BGR2GRAY);
	
	//2li]ŌʂςA{͔wiŕ̂j
	BOOL bInv = checkInv(hWnd);
	if (bInv){
		cv::threshold(grayImage, binImage, 0.0, 255.0, CV_THRESH_BINARY_INV | CV_THRESH_OTSU);
	}
	else{
		cv::threshold(grayImage, binImage, 0.0, 255.0, CV_THRESH_BINARY | CV_THRESH_OTSU);
	}
	cv::imshow("bin", binImage);

	//֊s̍WXg
	std::vector< std::vector< cv::Point > > contours;

	//֊s擾
	////cv::findContours(binImage, contours, CV_RETR_EXTERNAL, CV_CHAIN_APPROX_NONE);
	cv::findContours(binImage, contours, CV_RETR_LIST, CV_CHAIN_APPROX_NONE);

	// oꂽ֊s΂ŕ`
	for (auto contour = contours.begin(); contour != contours.end(); contour++){
		cv::polylines(imgIn, *contour, true, cv::Scalar(0, 255, 0), 2);
	}	

	//֊s̐
	int roiCnt = 0;

	//֊s̃JEg	
	int i = 0;

	for (auto contour = contours.begin(); contour != contours.end(); contour++){

		std::vector< cv::Point > approx;
		
		//֊s𒼐ߎ
		cv::approxPolyDP(cv::Mat(*contour), approx, 0.1 * cv::arcLength(*contour, true), true);
		
		// ߎ̖ʐςȏȂ擾
		double area = cv::contourArea(approx);

		if (area > 1000.0){	
			//ň͂ޏꍇ			
			cv::polylines(imgIn, approx, true, cv::Scalar(255, 0, 0), 2);
			std::stringstream sst;
			sst << "area : " << area;
			cv::putText(imgIn, sst.str(), approx[0], CV_FONT_HERSHEY_PLAIN, 1.0, cv::Scalar(0, 128, 0));
			
			//֊sɗאڂ`̎擾
			cv::Rect brect = cv::boundingRect(cv::Mat(approx).reshape(2));
			roi[roiCnt] = cv::Mat(imgIn, brect);

			//͉摜ɕ\ꍇ
			//cv::drawContours(imgIn, contours, i, CV_RGB(0, 0, 255), 4);

			//\
			cv::imshow("label" + std::to_string(roiCnt+1), roi[roiCnt]);
		
			roiCnt++;

			//Ôߗ֊sJEg
			if (roiCnt == 99)
			{
				break;
			}
		}

		i++;
	}

	//Ŝ\ꍇ
	//cv::imshow("coun", imgIn);

	//Kvɉĕۑ摜ݒ肷
	imgMatWrite = imgIn;
}

/*------------------------------------------------
2
-------------------------------------------------*/
void func2(HWND hWnd)
{
	////MessageBox(hWnd, "func1", "debug", MB_OK);
	if (imgMatRead.rows == 0){
		MessageBox(hWnd, "摜t@Cł", "G[", MB_OK);
		return;
	}

	//͉摜Ał͖t@Cǂݍ
	cv::Mat imgIn = cv::imread((const std::string&)szOpenFileName, 1); //3`lJ[摜œǂݍ;

	//O[XP[
	cv::Mat grayImage, binImage;
	cv::cvtColor(imgIn, grayImage, CV_BGR2GRAY);

	//2li]ŌʂςA{͔wiŕ̂j
	BOOL bInv = checkInv(hWnd);
	if (bInv){
		cv::threshold(grayImage, binImage, 0.0, 255.0, CV_THRESH_BINARY_INV | CV_THRESH_OTSU);
	}
	else{
		cv::threshold(grayImage, binImage, 0.0, 255.0, CV_THRESH_BINARY | CV_THRESH_OTSU);
	}

	//֊s̍WXg
	std::vector< std::vector< cv::Point > > contours;

	//֊s̎擾
	////cv::findContours(binImage, contours, CV_RETR_EXTERNAL, CV_CHAIN_APPROX_NONE);
	cv::findContours(binImage, contours, CV_RETR_LIST, CV_CHAIN_APPROX_NONE);

	// oꂽ֊s΂ŕ`
	for (auto contour = contours.begin(); contour != contours.end(); contour++){
		cv::polylines(imgIn, *contour, true, cv::Scalar(0, 255, 0), 2);
	}	

	//`̐
	int roiCnt = 0;

	//֊s̃JEg
	int i = 0;

	for (auto contour = contours.begin(); contour != contours.end(); contour++){

		std::vector< cv::Point > approx;

		//ʕ̎擾i_̓ftHg̔vj
		cv::convexHull(*contour, approx);

		//ʕ̎擾ʐςȏȂ擾
		double area = cv::contourArea(approx);

		if (area > 1000.0){
			//ň͂ޏꍇ			
			cv::polylines(imgIn, approx, true, cv::Scalar(255, 0, 0), 2);
			std::stringstream sst;
			sst << "area : " << area;
			cv::putText(imgIn, sst.str(), approx[0], CV_FONT_HERSHEY_PLAIN, 1.0, cv::Scalar(0, 128, 0));

			//֊sɗאڂ`̎擾
			cv::Rect brect = cv::boundingRect(cv::Mat(approx).reshape(2));
			roi[roiCnt] = cv::Mat(imgIn, brect);

			//\
			cv::imshow("label" + std::to_string(roiCnt + 1), roi[roiCnt]);

			roiCnt++;

			//Ôߋ`̐`FbN
			if (roiCnt == 99)
			{
				break;
			}
		}

		i++;
	}

	//Ŝ\ꍇ
	///cv::imshow("coun", imgIn);

	//Kvɉĕۑ摜ݒ肷
	imgMatWrite = imgIn;
}

/*------------------------------------------------
3
-------------------------------------------------*/
void func3(HWND hWnd)
{
	////MessageBox(hWnd, "func1", "debug", MB_OK);
	if (imgMatRead.rows == 0){
		MessageBox(hWnd, "摜t@Cł", "G[", MB_OK);
		return;
	}

	//͉摜Ał͖t@Cǂݍ
	cv::Mat imgIn = cv::imread((const std::string&)szOpenFileName, 1); //3`lJ[摜œǂݍ;

	//O[XP[
	cv::Mat grayImage, binImage;
	cv::cvtColor(imgIn, grayImage, CV_BGR2GRAY);

	//2li]ŌʂςA{͔wiŕ̂j
	BOOL bInv = checkInv(hWnd);
	if (bInv){
		cv::threshold(grayImage, binImage, 220.0, 255.0, CV_THRESH_OTSU || CV_THRESH_BINARY_INV);
	}
	else{
		cv::threshold(grayImage, binImage, 220.0, 255.0, CV_THRESH_OTSU);
	}
	//cv::imshow("bin", binImage);

	//֊s̍WXg
	std::vector< std::vector< cv::Point > > contours;

	//֊s̎擾
	////cv::findContours(binImage, contours, CV_RETR_EXTERNAL, CV_CHAIN_APPROX_NONE);
	cv::findContours(binImage, contours, CV_RETR_LIST, CV_CHAIN_APPROX_NONE);

	// oꂽ֊s΂ŕ`
	for (auto contour = contours.begin(); contour != contours.end(); contour++){
		cv::polylines(imgIn, *contour, true, cv::Scalar(0, 255, 0), 2);
	}	

	//`̐
	int roiCnt = 0;

	//֊s̃JEg
	int i = 0;

	for (auto contour = contours.begin(); contour != contours.end(); contour++){

		std::vector< cv::Point > approx;

		//ʕ̎擾i_̓ftHg̔vj
		cv::convexHull(*contour, approx);

		//ʕ̎擾ʐςȏŎlp`Ȃ擾
		double area = cv::contourArea(approx);

		if (approx.size() == 4 && area > 1000.0){
			//ň͂ޏꍇ			
			cv::polylines(imgIn, approx, true, cv::Scalar(255, 0, 0), 2);
			std::stringstream sst;
			sst << "area : " << area;
			cv::putText(imgIn, sst.str(), approx[0], CV_FONT_HERSHEY_PLAIN, 1.0, cv::Scalar(0, 128, 0));

			//͉摜ɕ\ꍇ
			//cv::drawContours(imgIn, contours, i, CV_RGB(0, 0, 255), 4);

			//lp`̏ꍇŁARectōW؂o
			//RAcv::boundingRect ło邱
			roi[roiCnt] = cv::Mat(imgIn, cv::Rect(approx[2].x, approx[2].y, approx[3].x - approx[2].x, approx[0].y - approx[3].y));

			//\
			cv::imshow("label" + std::to_string(roiCnt + 1), roi[roiCnt]);

			roiCnt++;

			//Ôߋ`̐`FbN
			if (roiCnt == 99)
			{
				break;
			}
		}

		i++;
	}

	//Ŝ\ꍇ
	///cv::imshow("coun", imgIn);

	//Kvɉĕۑ摜ݒ肷
	imgMatWrite = imgIn;
}

/*------------------------------------------------
4
-------------------------------------------------*/
void func4(HWND hWnd)
{
	MessageBox(hWnd, "func3", "debug", MB_OK);
}

/*------------------------------------------------
5
-------------------------------------------------*/
void func5(HWND hWnd)
{
	MessageBox(hWnd, "func5", "debug", MB_OK);
}

/*------------------------------------------------
 I
-------------------------------------------------*/
void terminateProc()
{
	//OpenCVWindowsN[Y
	cv::destroyAllWindows();

	//摜̗̈̉
	if (imgFromOpenCV != NULL){
		HeapFree(GetProcessHeap(), 0, bmpData); //ꉞ
	}
}

/*----------------------------------------------
 _CAOvV[W
-----------------------------------------------*/
LRESULT CALLBACK DlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int ret;
	RECT rect;

	float rateW, rateH, rate;
	int imgBoxWidth, imgBoxHeight;

	int id = LOWORD(wParam);

	switch (message)
	{
	case WM_INITDIALOG:                // _CAȌ

		hwPic = GetDlgItem(hDlg, IDC_PICTURE);
		hDC = GetDC(hwPic);

		return TRUE;

	case WM_PAINT:

		//ǂݍ݉摜̕\
		if (imgFromOpenCV != NULL){
			StretchDIBits(hDC,
				0, 0, imgFromOpenCV->width, imgFromOpenCV->height,
				0, 0, imgFromOpenCV->width, imgFromOpenCV->height,
				bmpData, &bmpInfo, DIB_RGB_COLORS, SRCCOPY);
		}

		break;

	case WM_COMMAND:
		switch (id)
		{
		case ID_READ:

			//摜ǂݍ
			ret = openFileNameBox(hDlg);

			if (ret == 0){
				imgMatRead = cv::imread((const std::string&)szOpenFileName, 1); //3`lJ[摜œǂݍ

				if (imgMatRead.rows == 0){
					MessageBox(hDlg, "摜t@Cł", "G[", MB_OK);
					return FALSE;
				}

				//TCỸ`FbN
				GetWindowRect(hwPic, &rect);

				imgBoxWidth = rect.right - rect.left;
				imgBoxHeight = rect.bottom - rect.top;

				rateW = (float)imgBoxWidth / (float)imgMatRead.cols;
				rateH = (float)imgBoxHeight / (float)imgMatRead.rows;

				rate = 1.0f;

				//kKvȏꍇ́Ac\悤ɏkĕ\
				if ((rateH < (float)1.0) || (rateW < (float)1.0))
				{
					if (rateH < rateW){
						rate = rateH;
					}
					else
					{
						rate = rateW;
					}
				}

				if (rate < 1.0f)
				{
					// INTER_LINERiftHg̃oCjAԁjł̃TCYύX
					cv::resize(imgMatRead, imgMatFix, cv::Size(), rate, rate);
					img = imgMatFix;
				}
				else
				{
					img = imgMatRead;
				}

				imgFromOpenCV = &img;

				imgMatWrite = imgMatRead;

				//
				if (bmpData != NULL){
					HeapFree(GetProcessHeap(), 0, bmpData);
				}

				//m
				bmpData = (LPDWORD)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, imgFromOpenCV->width * imgFromOpenCV->height * 4);

				//iplImageDIB֕ϊ
				iplTobmp(imgFromOpenCV, bmpInfo, bmpData);

				//܂͂ŕ`
				InvalidateRect(NULL, NULL, TRUE);

				//Ô߃bZ[W
				if (rate < 1.0f){
					MessageBox(hDlg, "摜kĕ\܂B", "摜\", MB_OK);
				}
			}

			break;

		case ID_SAVE:

			if (imgMatWrite.rows == 0){
				MessageBox(hDlg, "摜t@Cł", "G[", MB_OK);
				return FALSE;
			}

			//摜ۑ
			ret = saveFileNameBox(hDlg);

			if (ret == 0){
				cv::imwrite((const std::string&)szSaveFileName,imgMatWrite);
			}

			break;

		case IDC_MYICON:                    // ~{^̏
			EndDialog(hDlg, IDOK);
			terminateProc();

			return TRUE;

		case ID_CLOSE:                   // {^̏
			EndDialog(hDlg, IDCANCEL);
			terminateProc();

			return TRUE;

		case ID_EXEC1:
			func1(hDlg);
			break;

		case ID_EXEC2:
			func2(hDlg);
			break;

		case ID_EXEC3:
			func3(hDlg);
			break;

		case ID_EXEC4:
			func4(hDlg);
			break;

		case ID_EXEC5:
			func5(hDlg);
			break;

		default:
			break;
		}
		break;
	}
	return FALSE;
}

//---------------------------------------------------------------
//IplImage BMP(DIB)֕ϊ
//(͂3`lJ[摜ƂOAȊO͓ǂ߂Ȃ)
//---------------------------------------------------------------
void iplTobmp(const IplImage* srcIplImage, BITMAPINFO& bmpInfo, unsigned long* bmpData)
{
	int width = srcIplImage->width;
	int height = srcIplImage->height;

	ZeroMemory(&bmpInfo, sizeof(bmpInfo));
	bmpInfo.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	bmpInfo.bmiHeader.biWidth = width;
	bmpInfo.bmiHeader.biHeight = height;
	bmpInfo.bmiHeader.biPlanes = 1;
	bmpInfo.bmiHeader.biBitCount = 32;
	bmpInfo.bmiHeader.biCompression = BI_RGB;

	unsigned long pixel;
	unsigned char r, g, b;
	for (int i = 0; i < height; i++){
		for (int j = 0; j < width; j++){
			b = srcIplImage->imageData[srcIplImage->widthStep * i + j * 3];
			g = srcIplImage->imageData[srcIplImage->widthStep * i + j * 3 + 1];
			r = srcIplImage->imageData[srcIplImage->widthStep * i + j * 3 + 2];
			pixel = 0x00000000;
			pixel = (r << 16) + (g << 8) + b;
			bmpData[j + (height - i - 1) * width] = pixel;
		}
	}
}

/*-----------------------------------
	I[vt@C擾
-------------------------------------*/
int openFileNameBox(HWND hWnd)
{
	int i;

	OPENFILENAME ofn;

	memset(&ofn, 0, sizeof(OPENFILENAME));  // \̂̏

	ofn.lStructSize = sizeof(OPENFILENAME); //\̂̃TCY
	ofn.hwndOwner = hWnd;   //eEBhẼnh
	ofn.lpstrFilter = TEXT("All(*.*)\0*.*\0JPEGt@C(*.jpg)\0*.jpg\0PNGt@C(*.png)\0*.png\0\0"); //tB^[
	ofn.lpstrFile = szOpenFileName;     // tpXt@C
	ofn.nMaxFile = sizeof(szOpenFileName);      //tpXt@C̃TCY
	ofn.lpstrFileTitle = szOpenFileName;       //t@C
	ofn.nMaxFileTitle = sizeof(szOpenFileName);        //t@C̃TCY
	
	//t@Ĉݓ͋ | ǂݎ`FbN{bNX\Ȃ
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.lpstrDefExt = TEXT("*");                    //ftHg̊gq
	ofn.lpstrTitle = TEXT("摜t@C̓Ǎ");      //^Cgo[ɕ\镶
	
	i = GetOpenFileName(&ofn);
	if (i == 0) {      //OK{^ĂȂ
		return 1;
	}
	
	///MessageBox(hWnd, szOpenFileName, TEXT("debug"), MB_OK);
	
	return 0;
}

/*-----------------------------------
	ۑt@C擾
-------------------------------------*/
int saveFileNameBox(HWND hWnd)
{
	int i;

	OPENFILENAME ofn;

	memset(&ofn, 0, sizeof(OPENFILENAME));  // \̂̏

	ofn.lStructSize = sizeof(OPENFILENAME); //\̂̃TCY
	ofn.hwndOwner = hWnd;   //eEBhẼnh
	ofn.lpstrFilter = TEXT("All(*.*)\0*.*\0JPEGt@C(*.jpg)\0*.jpg\0PNGt@C(*.png)\0*.png\0\0"); //tB^[
	ofn.lpstrFile = szSaveFileName;     // tpXt@C
	ofn.nMaxFile = sizeof(szSaveFileName);      //tpXt@C̃TCY
	ofn.lpstrFileTitle = szSaveFileName;       //t@C
	ofn.nMaxFileTitle = sizeof(szSaveFileName);        //t@C̃TCY
	ofn.Flags = OFN_OVERWRITEPROMPT;        // ㏑mF_CAO̕\
	ofn.lpstrDefExt = TEXT("*");    //ftHg̊gq
	ofn.lpstrTitle = TEXT("摜t@C̕ۑ");        //^Cgo[ɕ\镶
	
	i = GetSaveFileName(&ofn);        //t@Ctĕۑ_CAO{bNX
	if (i == 0) {      //OK{^ĂȂ
		return 1;
	}

	////MessageBox(hWnd, szSaveFileName, TEXT("debug"), MB_OK);
	
	return 0;
}

/*-----------------------------------------------------
	C֐
-------------------------------------------------------*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPSTR lpCmdLine, int nCmdShow)
{
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_MAIN_DIALOG), NULL, (DLGPROC)DlgProc);
	return 0;
}

